#<profile4xi profile = "11"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "verify2uri4xi.py">
#<abstract4xi abstract = "verifies HTML tags in dragonized HTML files"/>
#<refer4xi reference = "Studio4Xi"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
#<use4xi usage = "
#
# 1) go to Studio4Xi in commmand mode
#       > go3studio4fb <-- Python 3 version of Studio4Xi in Fastblack workstation (fb)
#       Tip: you could use the same go2studio4xi-command in all workstations just varying the content! 
#
# 2) edit version4xi.py
#       'input2verify4uri':      '..//..//..//..//studio4xi//python//3.3//html//', <-- change folder to be checked!
#
# 3) edit verify2uri4xi.py
#       extension2file = '4xi.html' <-- change to '.html' to process all HTML-files
#       debug2xi  = False      <-- Tue = display all messages / False = display only meaningful ones
#       
# 4) >verify2uri4xi <-- run command
#
# 5) view verifying results in temp folder, for example E:\STUDIO4XI\Python\3.3\temp\verify2uri4xi.txt
#    *** ERROR POSSIBILITY <-- look for these and correct the source HTML-file, if necessary, by going to the suspected!
#
# 6) continue
# 6a) if verifying is OK, finish
# 6b) is there are any verifying errors, correct the files and go to step 3 to verify all again.
#
#"
#/>


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'verify2uri4xi' ]
#"
#/>



# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass

#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from time4xi import time4xi    
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global path2verify4xi

global tagindexes4line
global tagminimums4module

global tagstats4module 
global tagstats4system
global tagstats4line 

global tagvalues4attributes

global TagKB4Xi
global keys2tags
global keys2start
global keys2end
global keys2skip

global extension2file

global start2style     
global end2style      
global start2paragraph
global end2paragraph  
global start2anchor   
global end2anchor      
global start2table     
global end2table       
global start2tablebody 
global end2tablebody   
global start2tr        
global end2tr          
global start2td       
global end2td          
global start2header2   
global end2header2     
global start2HEADER2   
global end2HEADER2     

global debug2xi

#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
debug2xi = False


path2verify4xi = VersionKB4Xi['input2verify4uri']
extension2file = '.html' 

start2style     = '<style'
end2style       = '</style>'
start2paragraph = '<p'
end2paragraph   = '</p>'
start2anchor    = '<a'
end2anchor      = '</a>'
start2table     = '<table'
end2table       = '</table>'
start2tablebody = '<tbody'
end2tablebody   = '</tbody>'
start2tr        = '<tr'
end2tr          = '</tr>'
start2td        = '<td'
end2td          = '</td>'
start2header2   = '<h2'
end2header2     = '</h2>'
start2HEADER2   = '<H2'
end2HEADER2     = '</H2>'
start2strong    = '<strong>'
end2strong      = '</strong>'

# -------------------------------------------------------------------------------------------------
# TAGS KNOWLEDGEBASE
# -------------------------------------------------------------------------------------------------
keys2tags =  {
          start2style,
          end2style,
          start2paragraph,
          end2paragraph,
          start2anchor,
          end2anchor,
          start2table,
          end2table,
          start2tablebody,
          end2tablebody,
          start2tr,
          end2tr,
          start2td,
          end2td,
          start2header2,
          end2header2,
          start2HEADER2,
          end2HEADER2,
          start2strong,
          end2strong
          }
if debug2xi is True:
    print(keys2tags) 
             
keys2start =  {
          start2style,
          start2paragraph,
          start2anchor,
          start2table,
          start2tablebody,
          start2tr,
          start2td,
          start2header2,
          start2HEADER2,
          start2strong
          }
if debug2xi is True:
    print(keys2start) 
                        
keys2end =  {
          end2style,
          end2paragraph,
          end2anchor,
          end2table,
          end2tablebody,
          end2tr,
          end2td,
          end2header2,
          end2HEADER2,
          end2strong
          }
if debug2xi is True:
    print(keys2end) 

                 
TagKB4Xi = {}
for key in keys2start:
    TagKB4Xi[key] = {}

if debug2xi is True:
    print(TagKB4Xi)     
    
# =====================================
# [1] ATTRIBUTE #1                                                                    
# =====================================
TagKB4Xi[start2style]     [1] = 'type'
TagKB4Xi[start2paragraph] [1] = None
TagKB4Xi[start2anchor]    [1] = 'target'
TagKB4Xi[start2table]     [1] = None
TagKB4Xi[start2tablebody] [1] = None
TagKB4Xi[start2tr]        [1] = None
TagKB4Xi[start2td]        [1] = None
TagKB4Xi[start2header2]   [1] = None
TagKB4Xi[start2HEADER2]   [1] = None
TagKB4Xi[start2strong]    [1] = None


# =====================================
# [2] ATTRIBUTE #2                                                                    
# =====================================
TagKB4Xi[start2style]     [2] = 'media'
TagKB4Xi[start2paragraph] [2] = None
TagKB4Xi[start2anchor]    [2] = None
TagKB4Xi[start2table]     [2] = None
TagKB4Xi[start2tablebody] [2] = None
TagKB4Xi[start2tr]        [2] = None
TagKB4Xi[start2td]        [2] = None
TagKB4Xi[start2header2]   [2] = None
TagKB4Xi[start2HEADER2]   [2] = None
TagKB4Xi[start2strong]    [2] = None


# =====================================
# [32] SYNONYM                                                                    
# =====================================
TagKB4Xi[start2style]     [32] = None
TagKB4Xi[start2paragraph] [32] = None
TagKB4Xi[start2anchor]    [32] = None
TagKB4Xi[start2table]     [32] = None
TagKB4Xi[start2tablebody] [32] = None
TagKB4Xi[start2tr]        [32] = None
TagKB4Xi[start2td]        [32] = None
TagKB4Xi[start2header2]   [32] = None
TagKB4Xi[start2HEADER2]   [32] = None
TagKB4Xi[start2strong]    [32] = None


# =====================================
# [33] END                                                                    
# =====================================
TagKB4Xi[start2style]     [33] = end2style
TagKB4Xi[start2paragraph] [33] = end2paragraph
TagKB4Xi[start2anchor]    [33] = end2anchor
TagKB4Xi[start2table]     [33] = end2table
TagKB4Xi[start2tablebody] [33] = end2tablebody
TagKB4Xi[start2tr]        [33] = end2tr
TagKB4Xi[start2td]        [33] = end2td
TagKB4Xi[start2header2]   [33] = end2header2
TagKB4Xi[start2HEADER2]   [33] = end2HEADER2
TagKB4Xi[start2strong]    [33] = end2strong

if debug2xi is True:
    print(TagKB4Xi)    

# -------------------------------------------------------------------------------------------------
# INDEXES FOUND FOR EACH TAG IN A SOURCE LINE, -1 = NOT FOUND
# -------------------------------------------------------------------------------------------------
tagindexes4line = {}
for key in keys2tags:
    tagindexes4line[key] = -1
    
if debug2xi is True:
    keys = tagindexes4line.keys()
    for key in keys:
        print(tagindexes4line[key])       
        
# -------------------------------------------------------------------------------------------------
# TAG STATISTICS FOR SYSTEM
# -------------------------------------------------------------------------------------------------
tagstats4system = {}

# tagstats4system ['..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html'] = {}
# tagstats4system ['..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html'] [start2anchor] = 0
# if debug2xi is True:
    # print('DEBUG TAGSTATS4SYSTEM: ', tagstats4system)    
    # {'..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html': {'<a': 0}} <-- YOU CAN HAVE FILE PATH AS A KEY! 
         
# -------------------------------------------------------------------------------------------------
# TAGS STATISTICS FOR MODULE
# -------------------------------------------------------------------------------------------------
tagstats4module = {}
for key in keys2tags:
    tagstats4module[key] = 0
    if debug2xi is True:
        print('DEBUG TAGSTATS4MODULE[', key, ']', tagstats4module[key])    
        # TAGSTATS4MODULE[ <h2 ] 0
        # TAGSTATS4MODULE[ <td ] 0
        # TAGSTATS4MODULE[ </a ] 0
        # TAGSTATS4MODULE[ <tr ] 0
        # TAGSTATS4MODULE[ </b> ] 0
        # TAGSTATS4MODULE[ </style> ] 0
        # TAGSTATS4MODULE[ </table> ] 0
        # TAGSTATS4MODULE[ </tbody> ] 0
        # TAGSTATS4MODULE[ </tr> ] 0
        # TAGSTATS4MODULE[ <table ] 0
        # TAGSTATS4MODULE[ </B> ] 0
        # TAGSTATS4MODULE[ <p ] 0
        # TAGSTATS4MODULE[ </p> ] 0
        # TAGSTATS4MODULE[ </h2> ] 0
        # TAGSTATS4MODULE[ <b ] 0
        # TAGSTATS4MODULE[ <a ] 0
        # TAGSTATS4MODULE[ <H2 ] 0
        # TAGSTATS4MODULE[ </td> ] 0
        # TAGSTATS4MODULE[ <style ] 0
        # TAGSTATS4MODULE[ </H2> ] 0
        # TAGSTATS4MODULE[ <tbody ] 0
        # TAGSTATS4MODULE[ <B ] 0  

# -------------------------------------------------------------------------------------------------
# TAGS STATISTICS FOR LINE
# -------------------------------------------------------------------------------------------------
tagstats4line = {}

                        
# -------------------------------------------------------------------------------------------------
# MINIMUM OF TAGS FOR MODULE
# -------------------------------------------------------------------------------------------------
tagminimums4module = {} 
for key in keys2tags:
    tagminimums4module [key] = 0   

    if debug2xi is True:
        print('DEBUG TAGMINIMUMS4MODULE[', key, ']', tagminimums4module[key])        
        # TAGMINIMUMS4MODULE[ <h2 ] 0
        # TAGMINIMUMS4MODULE[ <td ] 0
        # TAGMINIMUMS4MODULE[ </a ] 0
        # TAGMINIMUMS4MODULE[ <tr ] 0
        # TAGMINIMUMS4MODULE[ </b> ] 0
        # TAGMINIMUMS4MODULE[ </style> ] 0
        # TAGMINIMUMS4MODULE[ </table> ] 0
        # TAGMINIMUMS4MODULE[ </tbody> ] 0
        # TAGMINIMUMS4MODULE[ </tr> ] 0
        # TAGMINIMUMS4MODULE[ <table ] 0
        # TAGMINIMUMS4MODULE[ </B> ] 0
        # TAGMINIMUMS4MODULE[ <p ] 0
        # TAGMINIMUMS4MODULE[ </p> ] 0
        # TAGMINIMUMS4MODULE[ </h2> ] 0
        # TAGMINIMUMS4MODULE[ <b ] 0
        # TAGMINIMUMS4MODULE[ <a ] 0
        # TAGMINIMUMS4MODULE[ <H2 ] 0
        # TAGMINIMUMS4MODULE[ </td> ] 0
        # TAGMINIMUMS4MODULE[ <style ] 0
        # TAGMINIMUMS4MODULE[ </H2> ] 0
        # TAGMINIMUMS4MODULE[ <tbody ] 0
        # TAGMINIMUMS4MODULE[ <B ] 0    
# -------------------------------------------------------------------------------------------------
# ALLOWED ATTRIBUTE VALUES
# -------------------------------------------------------------------------------------------------
          
tagvalues4attributes = {
    '<profile4xi': {1: '11', 2: '12', 3: '13', 4: '21', 5: '22', 6: '23', 7:'31', 8:'32', 9:'33'} 
    } 

# -------------------------------------------------------------------------------------------------
# ALLOWED ATTRIBUTE VALUES
# -------------------------------------------------------------------------------------------------
#   KEY   FUNCTION4XI CLASS4XI METHODIZE4XI DESCRIPTION       
profiles4tags = {

      '00': {11: 'nack2function',  12: 'nack2special', 21: 'nack2class',  22: 'nack2methods',  23: 'nack2stub', 24: 'nack4embed', 25: 'nack2function',  26: 'nack2special', 27: 'nack2test', 30: 'no functions nor any classes; for example import4xi.py, verb modules, some xml modules, types'},
      '10': {11: 'ack2function',   12: 'nack2special', 21: 'nack2class',  22: 'nack2methods',  23: 'nack2stub', 24: 'nack4embed', 25: 'nack2function',  26: 'nack2special', 27: 'nack2test', 30: 'function(s): normal function(s)'},
      '20': {11: 'nack2function',  12: 'nack2special', 21: 'nack2class',  22: 'nack2methods',  23: 'nack2stub', 24: 'nack4embed', 25: 'nack2function',  26: 'nack2special', 27: 'nack2test', 30: 'Function(s): special function(s)'},
      '30': {11: 'ack2function',   12: 'ack2special',  21: 'nack2class',  22: 'nack2methods',  23: 'nack2stub', 24: 'nack4embed', 25: 'nack2function',  26: 'nack2special', 27: 'nack2test', 30: 'both noremal function(s) and special Function(s)'},
      '01': {11: 'nack2function',  12: 'nack2special', 21: 'ack2class',   22: 'nack2methods',  23: 'ack2stub',  24: 'nack4embed', 25: 'nack2function',  26: 'nack2special', 27: 'nack2test', 30: 'stub Class'},
      '02': {11: 'nack2function',  12: 'nack2special', 21: 'ack2class',   22: 'ack2methods',   23: 'nack2stub', 24: 'nack4embed', 25: 'nack2function',  26: 'nack2special', 27: 'nack2test', 30: 'normal Class with methods'},
      '03': {11: 'nack2function',  12: 'nack2special', 21: 'ack2class',   22: 'ack2methods',   23: 'nack2stub', 24: 'ack4embed',  25: 'nack2function',  26: 'nack2special', 27: 'nack2test', 30: 'Class with embedded functions !'},
      '11': {11: 'ack2function',   12: 'nack2special', 21: 'nack2class',  22: 'nack2methods',  23: 'nack2stub', 24: 'nack4embed', 25: 'ack2function',   26: 'nack2special', 27: 'ack2test',  30: 'normal function(s) and normal functions(s); test programs have this profile'},
      '12': {11: 'ack2function',   12: 'nack2special', 21: 'ack2class',   22: 'ack2methods',   23: 'nack2stub', 24: 'nack4embed', 25: 'nack2function',  26: 'nack2special', 27: 'nack2test', 30: 'normal function(s) and normal Class(es) with methods'},
      '13': {11: 'ack2function',   12: 'nack2special', 21: 'ack2class',   22: 'ack2methods',   23: 'ack2stub',  24: 'nack4embed', 25: 'nack2function',  26: 'nack2special', 27: 'nack2test', 30: 'normal function(s) and both stub Class and normal Class'},
      '21': {11: 'nack2function',  12: 'ack2special',  21: 'ack2class',   22: 'nack2methods',  23: 'ack2stub',  24: 'nack4embed', 25: 'nack2function',  26: 'nack2special', 27: 'nack2test', 30: 'special Function(s) and stub Class'},
      '22': {11: 'nack2function',  12: 'ack2special',  21: 'ack2class',   22: 'ack2methods',   23: 'nack2stub', 24: 'nack4embed', 25: 'nack2function',  26: 'nack2special', 27: 'nack2test', 30: 'special Function(s) and normal Class with methods'},
      '23': {11: 'nack2function',  12: 'ack2special',  21: 'ack2class',   22: 'ack2methods',   23: 'ack2stub',  24: 'nack4embed', 25: 'nack2function',  26: 'nack2special', 27: 'nack2test', 30: 'special Function(s) and both stub Class and normal Class'},
      '31': {11: 'ack2function',   12: 'ack2special',  21: 'ack2class',   22: 'nack2methods',  23: 'ack2stub',  24: 'nack4embed', 25: 'nack2function',  26: 'nack2special', 27: 'nack2test', 30: 'both normal function(s) and special Function(s) and stub Class'},
      '32': {11: 'ack2function',   12: 'ack2special',  21: 'nack2class',  22: 'nack2methods',  23: 'nack2stub', 24: 'nack4embed', 25: 'nack2function',  26: 'ack2special',  27: 'nack2test', 30: 'both normal function(s) and special Function(s) and in body special Functions(s)'},
      '33': {11: 'ack2function',   12: 'ack2special',  21: 'ack2class',   22: 'ack2methods',   23: 'ack2stub',  24: 'ack4embed',  25: 'ack2function',   26: 'ack2special',  27: 'ack2test',  30: 'ALL' }
 
 }
            
#"
#"/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "verify2uri4xi" usage = "
#   verifying a source file
#"> 
# -------------------------------------------------------------------------------------------------
def verify2uri4xi(fullName):
    debug2xi

    global path2verify4xi

    global tagindexes4line
    global tagminimums4module
    
    global tagstats4line 
    global tagstats4module 
    global tagstats4system
    global tagvalues4attributes

    global TagKB4Xi
    global keys2tags
    global keys2start
    global keys2end

    global extension2file

    global start2style     
    global end2style      
    global start2paragraph
    global end2paragraph  
    global start2anchor   
    global end2anchor      
    global start2table     
    global end2table       
    global start2tablebody 
    global end2tablebody   
    global start2tr        
    global end2tr          
    global start2td       
    global end2td          
    global start2header2   
    global end2header2     
    global start2HEADER2   
    global end2HEADER2    


                   
    # -------------------------------------------------------------------------------------------------    
    # STEP 1
    # -------------------------------------------------------------------------------------------------         
    if debug2xi is True:
        print ('(STEP 0A/33) OF VERIFY2URI4XI - PASSED: ', fullName)
        # ..//..//..//..//studio4xi//python//3.3//html//en_mp_sw_xi4.html
        # ..//..//..//..//studio4xi//python//3.3//html//index.html
        # ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html
    
    name2xi=os.path.splitext(fullName) 
    if debug2xi is True:
        print ('(STEP 0B/33) OF VERIFY2URI4XI - NAME2XI: ', name2xi)
        # ('..//..//..//..//studio4xi//python//3.3//html//index2studio4xi', '.html')
         
    # -------------------------------------------------------------------------------------------------    
    # STEP 1
    # -------------------------------------------------------------------------------------------------
    text2find = extension2file
    index2dragon = str.find(fullName, text2find)  
    if index2dragon == -1:
        if debug2xi is True:
            print ('(STEP 1A/33) OF VERIFY2URI4XI - SKIPPED: ', fullName)
            # ..//..//..//..//studio4xi//python//3.3//html//en_mp_sw_xi4.html
            # ..//..//..//..//studio4xi//python//3.3//html//index.html       
    else:    
        # ---------------------------------------------------------------------------------------------
        # STEP 2: OK FILE BEING VERIFIED
        # ---------------------------------------------------------------------------------------------     
        if debug2xi is True:
            print ('(STEP 2A/33) OF VERIFY2URI4XI - GOT VALID FILE: ', fullName)
            # ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html

        if debug2xi is True:
            try:
                print ('(STEP 0/33) OF VERIFY2URI4XI - GLOBAL: ')
                print('TAGMINIMUMS4MODULE: ', tagminimums4module)
                # {'</td>': 0 ... '<p': 0}              
                print('TAGINDEXES4LINE: ', tagindexes4line)
                # {'<h2': -1 ... '<B': -1}
                print('TAGMINIMUMS4MODULE: ', tagminimums4module)
                # {'</td>': 0 ... '<p': 0}
                print('TAGSTATS4SYSTEM: ', tagstats4system)
                # {}
                print('TAGSTATS4MODULE: ', tagstats4module)
                # {'</td>': 0, '</tbody>': 0, '</H2>': 0, '<B': 0 ...
                print('TAGSTATS4LINE: ', tagstats4line)
                # 
                print('TAGVALUES4ATTRIBUTES: ', tagvalues4attributes)
                # {'<profile4xi': {1: '11', 2: '12' ...
                print('TAGKB4XI: ', TagKB4Xi)
                # {'<tr': {32: None, 1: None, 2: None, 33: '</tr>'}, '<b': {32: None, 1: None, 2: None, 33: '</b>'} ...
                
                print('KEYS2TAG: ', keys2tags)
                # {'<table', '</B>', '</table>', '</tr>', '</h2>', '</a', '<style' ...
                print('KEYS2START: ', keys2start)
                # {'<td', '<table', '<B', '<tr', '<tbody', '<h2', '<H2', '<p', '<style', '<b', '<a'}
                print('KEYS2END: ', keys2end)
                # {'</style', '</h2>', '</b>', '</td>', '</table>', '</tr>', '</p>', '</H2>', '</a', '</tbody>', '</B>'}
    
                print('EXTENSION2FILE: ', extension2file)
                # 4xi.html
                print('START2STYLE: ', start2style)
                # <style
                print('END2STYLE: ', end2style)
                # </style>
                print('START2PARAGRAPH: ', start2paragraph)
                # <p 
                print('END2PARAGRAPH: ', end2paragraph)
                # </p>
                print('START2ANCHOR: ', start2anchor)
                # <a
                print('END2ANCHOR: ', end2anchor)
                # </a
                print('START2TABLE: ', start2table)
                # <table
                print('END2TABLE: ', end2table)
                # </table>
                print('START2TABLEBODY: ', start2tablebody)
                # <tbody
                print('END2TABLEBODY: ', end2tablebody)
                # </tbody>
                print('START2TR: ', start2tr)
                # <tr
                print('END2TR: ', end2tr)
                # </tr>
                print('START2TD: ', start2td)
                # <td
                print('END2TD: ', end2td)
                # </td>
                print('START2header2: ', start2header2)
                # <h2 
                print('END2header2: ', end2header2)
                # </h2> 
                print('START2HEADER2: ', start2HEADER2)
                # <H2
                print('END2HEADER2: ', end2HEADER2)
                # </H2>
            except:
                print ('(STEP 2Z1/33) OF VERIFY2URI4XI *** FAILED TO PRINT GLOBALS ***')           
        
        ack2tag = True
        if debug2xi is True:        
            print ('(STEP 2B1/33) OF VERIFY2URI4XI - INITIALIZING FOR MODULE ACK2TAG ', ack2tag )
       
        if debug2xi is True:        
            print ('(STEP 2B2/33) OF VERIFY2URI4XI - INITIALIZING MODULE STATISTICS FOR THIS FILE ', fullName)

        try:             
            # -----------------------------------------------------------------------------------------
            # INITIALIZE TAGS STATISTICS FOR MODULE
            # -----------------------------------------------------------------------------------------                                     
            tagstats4module = {}
            for key in keys2tags:
                tagstats4module[key] = 0
                if debug2xi is True:
                    print('TAGSTATS4MODULE[', key, ']: ', tagstats4module[key]) 
                    # TAGSTATS4MODULE[ <tbody ]:  0
                    # TAGSTATS4MODULE[ <b ]:  0
                    # TAGSTATS4MODULE[ <H2 ]:  0
                    # TAGSTATS4MODULE[ </tr> ]:  0
                    # TAGSTATS4MODULE[ <a ]:  0
                    # TAGSTATS4MODULE[ <table ]:  0
                    # TAGSTATS4MODULE[ </b> ]:  0
                    # TAGSTATS4MODULE[ </h2> ]:  0
                    # TAGSTATS4MODULE[ <td ]:  0
                    # TAGSTATS4MODULE[ <style ]:  0
                    # TAGSTATS4MODULE[ <p ]:  0
                    # TAGSTATS4MODULE[ </tbody> ]:  0
                    # TAGSTATS4MODULE[ <tr ]:  0
                    # TAGSTATS4MODULE[ </td> ]:  0
                    # TAGSTATS4MODULE[ </B> ]:  0
                    # TAGSTATS4MODULE[ </H2> ]:  0
                    # TAGSTATS4MODULE[ </style> ]:  0
                    # TAGSTATS4MODULE[ </table> ]:  0
                    # TAGSTATS4MODULE[ </a ]:  0
                    # TAGSTATS4MODULE[ </p> ]:  0
                    # TAGSTATS4MODULE[ <h2 ]:  0
                    # TAGSTATS4MODULE[ <B ]:  0                    
        except:
            print ('(STEP 2Z2/33) OF VERIFY2URI4XI *** FAILED TO INITIALIZE MODULE STATISTICS FOR THIS FILE ', fullName)
            #
        try:             
            # -----------------------------------------------------------------------------------------
            # INITIALIZE LINE STATISTICS
            # -----------------------------------------------------------------------------------------                                     
            tagstats4module = {}
            for key in keys2tags:
                tagstats4module[key] = 0
                if debug2xi is True:
                    print('TAGSTATS4LINE[', key, ']: ', tagstats4module[key]) 
                    #                
        except:
            print ('(STEP 2Z3/33) OF VERIFY2URI4XI *** FAILED TO INITIALIZE LINE STATISTICS FOR THIS FILE ', fullName)
            #
        try:                
            # -------------------------------------------------------------------------------------------------
            # INITIALIZE INDEXES FOUND FOR EACH TAG IN A SOURCE LINE, -1 = NOT FOUND
            # -------------------------------------------------------------------------------------------------
            tagindexes4line = {}
            for key in keys2tags:
                tagindexes4line[key] = -1
        except:
            print ('(STEP 2Z4/33) OF VERIFY2URI4XI *** FAILED TO INITIALIZE INDEXES FOUND FOR EACH TAG IN A SOURCE LINE ', fullName)
            #
        try:
            # -------------------------------------------------------------------------------------------------
            # INITIALIZE MINIMUM OF TAGS FOR MODULE
            # -------------------------------------------------------------------------------------------------
            tagminimums4module = {} 
            for key in keys2tags:
                tagminimums4module [key] = 0           
        except:
            print ('(STEP 2Z5/33) OF VERIFY2URI4XI *** FAILED TO INITIALIZE MINIMUM OF TAGS FOR MODULE ', fullName)
            #
        # -----------------------------------------------------------------------------------------
        # USE FUNCTION VARIABLE FILE2XI
        # -----------------------------------------------------------------------------------------     
        file2xi = fullName
        if debug2xi is True:
            print ('(STEP 2C/33) OF VERIFY2URI4XI - VERIFYING FILE: ', file2xi, ' ', time4xi())
            # ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html
        
            print ('(STEP 2D/33) OF VERIFY2URI4XI - FIRST INITIALIZATION OF LINE STATISTICS FOR THIS FILE ', fullName)
        try:             
            # -----------------------------------------------------------------------------------------
            # FIRST INITIALIZATION OF LINE STATISTICS 
            # -----------------------------------------------------------------------------------------                                     
            tagstats4line = {}
            tagstats4line [file2xi] = {}
            number2tagstats4line = 0
            if debug2xi is True:
                print ('(STEP 2D2/33) OF VERIFY2URI4XI - FIRST INITIALIZATION OF LINE STATISTICS TAGSTATS4LINE[', file2xi, ']: ', tagstats4line [file2xi])
                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ]: {}
        except:
            print ('(STEP 2Z3/33) OF VERIFY2URI4XI *** FAILED FIRST IN INITIALIZATION OF LINE STATISTICS ', tagstats4line)
            #             
               
        
        # -----------------------------------------------------------------------------------------
        # SYSTEM STATISTICS
        # -----------------------------------------------------------------------------------------   
        if debug2xi is True:
            print ('(STEP 2E/33) OF VERIFY2URI4XI - SYSTEM STATISTICS TAGSTATS4SYSTEM: ', tagstats4system)
            # {'..//..//..//..//studio4xi//python//3.3//html//index.html': {'<td': 0, '<tbody': 0,
            #                                                               ...
            #                                                              '</h2>': 0}}

        # ---------------------------------------------------------------------------------------------
        # STEP 3: OPEN FILE FOR READING
        # ---------------------------------------------------------------------------------------------          
        input_file2xi = None
        try:
            input_file2xi = open(file2xi)
            if debug2xi is True:
                print ('(STEP 3A/33) OF VERIFY2URI4XI - OPENED FILE: ', file2xi, ' ', ' INPUT_FILE2XI: ', input_file2xi)
                # OPENED FILE:    ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html    
                # INPUT_FILE2XI:  <_io.TextIOWrapper name='..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html' mode='r' encoding='cp1252'>
     
        except:
            input_file2xi = None
            print ('(STEP 3Z1/33) OF VERIFY2URI4XI *** FAILED TO OPEN FILE2XI ', file2xi, ' INPUT_FILE2XI: ', input_file2xi)
            #

        if input_file2xi is None:             
            pass
        else:        
            # ---------------------------------------------------------------------------------------------
            # STEP 4 - ALL LINES IN A SOURCE FILE
            # ---------------------------------------------------------------------------------------------            
            while 1:
                # -----------------------------------------------------------------------------------------    
                # STEP 5 - READ LINE
                # -----------------------------------------------------------------------------------------     
                if debug2xi is True:
                    print ('(STEP 5A/33) OF VERIFY2URI4XI - READING THE NEXT LINE INPUT_FILE2XI: ', input_file2xi)
                    # <_io.TextIOWrapper name='..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html' mode='r' encoding='cp1252'>
                ack2read4line = False 
                try:
                    line2xi = input_file2xi.readline()
                    ack2read4line = True
                    number2tagstats4line = number2tagstats4line + 1
                    keys = tagindexes4line.keys()
                    for key in sorted(keys):
                        tagindexes4line[key] = -1       # initialize tag status not found in line   
                    if debug2xi is True:        
                        print ('(STEP 5B/33) OF VERIFY2URI4XI - GOT LINE: ', line2xi) 
                        # <style type="text/css" media="all">
                        # </style>
                        # <br /><a id="000"><b>Studio for Multiprocessing4Xi, Scope4Xi & DragonXi [Rel 7.21] [Py3.3] [OpenCLv1.2][Plone4.1][December 5 9:35 AM] [generate2all4scope] [build2hyperlink4content.py]</b></a>
                        # <a href="#001"><img src="https://www.yourdragonxi.org/web/images/png/1_q.png" alt="yourDragonXi" height="26" width="26" align="top" hspace="0" vspace="0" /></a>~ <b>M</b>acros <b>&Delta;</b><br />
                        # ...
                        # <br /><b>&xi;</b> <b>&raquo;</b><a href="../../../../sw4xi/python33/lib/multiprocessing4xi/verb4xi.py" target="_blank">verb4xi</a> 
                        
                        print ('(STEP 5C/33) OF VERIFY2URI4XI - SECOND INITIALIZATION OF LINE STATISTICS, NUMBER2TAGSTATS4LINE ', number2tagstats4line, ' FILE2XI ', file2xi)
                        # NUMBER2TAGSTATS4LINE  1  FILE2XI  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html
                    try:             
                        # -----------------------------------------------------------------------------------------
                        # SECOND INITIALIZATION OF LINE STATISTICS 
                        # -----------------------------------------------------------------------------------------                                     
                        tagstats4line [file2xi] [number2tagstats4line] = {}
                        for key in keys2tags:
                            tagstats4line [file2xi] [number2tagstats4line] [key] = 0
                            if debug2xi is True:
                                print('TAGSTATS4LINE[', file2xi, '] [', number2tagstats4line, '][', key, ']', tagstats4line [file2xi] [number2tagstats4line] [key]) 
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ <td ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ </table> ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ <table ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ <h2 ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ <tr ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ </tbody> ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ </b> ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ </tr> ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ </B> ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ <B ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ </td> ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ </a ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ <style ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ </h2> ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ </style> ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ <b ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ <tbody ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ <a ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ </p> ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ </H2> ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ <p ] 0
                                # TAGSTATS4LINE[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ][ <H2 ] 0                             
                    except:
                        print ('(STEP 5C/33) OF VERIFY2URI4XI *** FAILED IN INITIALIZATION OF LINE STATISTICS, NUMBER2TAGSTATS4LINE ', number2tagstats4line, ' FILE2XI ', file2xi)
                        #        
                    
                    
                except:
                    print ('(STEP 5Z1/33) OF VERIFY2URI4XI *** FAILED TO READ THE NEXT LINE INPUT_FILE2XI: ', input_file2xi)
                    # 
                    input_file2xi.close()
                    break
                if ack2read4line is True:          
                    if not line2xi:
                        # -------------------------------------------------------------------------------------    
                        # STEP 32 - ALL LINES VERIFIED - CLOSE FILE
                        # -------------------------------------------------------------------------------------     
                        if debug2xi is True:
                            print ('(STEP 32B/33) OF VERIFY2URI4XI - ALL LINES VERIFIED - CLOSING FILE: ', file2xi)
                            # ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html
                        try:
                            input_file2xi.close()
                            break
                        except:
                            print ('(STEP 32Z1/33) OF VERIFY2URI4XI *** ERROR *** FAILED TO CLOSE  FILE: ', file2xi, ' ', time4xi())    
                            break                                                          
                    else:
                        # -------------------------------------------------------------------------------------
                        # STEP 7 - CHECK ALL TAGS IN SOURCE LINE JATKA
                        # -------------------------------------------------------------------------------------             
                        keys = tagindexes4line.keys()
                        for key in sorted(keys):
                            tagindexes4line[key] = str.find(line2xi, key)      
                                                                                       
                        # -------------------------------------------------------------------------------------
                        # STEP 8 - UPDATE STATISTICS 
                        # -------------------------------------------------------------------------------------           
                        for key in sorted(keys2tags):
                            if tagindexes4line[key] == -1:
                                pass
                            else:
                                # -------------------------------------------------------------------------------------
                                # STEP 8A - UPDATE MODULE STATISTICS
                                # -------------------------------------------------------------------------------------
                                try:     
                                    tagstats4module[key] = tagstats4module[key] + 1
                                    if debug2xi is True:
                                        print ('(STEP 8A/33) OF VERIFY2URI4XI TAGSTATS4MODULE[',key, ']: ', tagstats4module[key])
                                        # TAGSTATS4MODULE[ <style ]:  1
                                        # TAGSTATS4MODULE[ </style> ]:  1 
                                        # ...
                                        # TAGSTATS4MODULE[ </a ]:  1
                                        # TAGSTATS4MODULE[ </b> ]:  1
                                        # TAGSTATS4MODULE[ <a ]:  1
                                        # TAGSTATS4MODULE[ <b ]:  1
                                        # ...
                                        # TAGSTATS4MODULE[ </a ]:  1119
                                        # TAGSTATS4MODULE[ </b> ]:  594
                                        # TAGSTATS4MODULE[ <a ]:  1119
                                        # TAGSTATS4MODULE[ <b ]:  2360
                          
                                    
                                except:
                                    print ('(STEP 8Z1/33) OF VERIFY2URI4XI *** ERROR *** FAILED TO UPDATE MODULE STATISTICS FOR FILE2XI: ', file2xi, ' ', time4xi())
                                                                        
                                # -------------------------------------------------------------------------------------
                                # STEP 8B - UPDATE SYSTEM STATISTICS
                                # -------------------------------------------------------------------------------------
                                try:
                                    tagstats4system[file2xi] [key] =  tagstats4system[file2xi] [key] + 1
                                    if debug2xi is True:
                                        print ('(STEP 8B/33) OF VERIFY2URI4XI TAGSTATS4SYSTEM[', file2xi, '] [', key, ']', tagstats4system[file2xi] [key]) 
                                        # TAGSTATS4SYSTEM[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ <style ] 1
                                        # TAGSTATS4SYSTEM[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ </style> ] 1
                                        # ...
                                        # TAGSTATS4SYSTEM[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ </a ] 1
                                        # TAGSTATS4SYSTEM[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ </b> ] 1
                                        # TAGSTATS4SYSTEM[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ <a ] 1
                                        # TAGSTATS4SYSTEM[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ <b ] 1
                                        # ...
                                        # TAGSTATS4SYSTEM[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ </a ] 1119
                                        # TAGSTATS4SYSTEM[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ </b> ] 594
                                        # TAGSTATS4SYSTEM[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ <a ] 1119
                                        # TAGSTATS4SYSTEM[ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ <b ] 2360                                                                             
                                except:
                                    print ('(STEP 8Z2/33) OF VERIFY2URI4XI *** ERROR *** FAILED TO UPDATE SYSTEM STATISTICS FOR FILE2XI: ', file2xi, ' ', time4xi())
                                    
                                # -------------------------------------------------------------------------------------
                                # STEP 8C - UPDATE LINE STATISTICS 
                                # -------------------------------------------------------------------------------------
                                try:
                                    tagstats4line[file2xi] [number2tagstats4line] [key] =  tagstats4line[file2xi] [number2tagstats4line] [key] + 1
                                    if debug2xi is True:
                                        print ('(STEP 8C/33) OF VERIFY2URI4XI TAGSTATS4LINE[ ', file2xi, '] [', number2tagstats4line, '] [', key, ']', tagstats4line[file2xi] [number2tagstats4line] [key]) 
                                        # TAGSTATS4LINE[  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 1 ] [ <style ] 1
                                        # TAGSTATS4LINE[  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 3 ] [ </style> ] 1
                                        
                                        # TAGSTATS4LINE[  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 4 ] [ <p ] 1
                                        
                                        # TAGSTATS4LINE[  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 5 ] [ </a ] 1
                                        # TAGSTATS4LINE[  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 5 ] [ <a ] 1
                                        
                                        # TAGSTATS4LINE[  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 7 ] [ <table ] 1
                                        # TAGSTATS4LINE[  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 8 ] [ <tbody ] 1
                                        
                                        # TAGSTATS4LINE[  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 9 ] [ <tr ] 1
                                        # TAGSTATS4LINE[  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 10 ] [ <td ] 1
                                        # TAGSTATS4LINE[  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 11 ] [ </td> ] 1
                                        # TAGSTATS4LINE[  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 12 ] [ </tr> ] 1
                                        # ...
                                        # TAGSTATS4LINE[  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 152 ] [ </tbody> ] 1
                                        # TAGSTATS4LINE[  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [ 153 ] [ </table> ] 1
                                    
                                                                                                         
                                except:
                                    print ('(STEP 8Z/33) OF VERIFY2URI4XI *** FAILED TO UPDATE LINE STATISTICS NUMBER2TAGSTATS4LINE ', number2tagstats4line, ' KEY ', key, ' FILE2XI ', file2xi , ' TAGSTATS4LINE ', tagstats4line) 
                                                     
                        # -------------------------------------------------------------------------------------
                        # EOF CHECKING TAGS IN SOURCE LINE
                        # ------------------------------------------------------------------------------------- 
                else:
                    print ('(STEP 11Z/33) OF VERIFY2URI4XI *** FAILED READING LINE - ACK2READ4LINE: ', ack2read4line)
                    # 
                    break
                    
    # ---------------------------------------------------------------------------------------------
    # END OF VERIFYING
    # ---------------------------------------------------------------------------------------------
    if debug2xi is True:
        print(33*("="))
        print ('(STEP 33/33) OF VERIFY2URI4XI - RETURNING ', time4xi())
        # 09:48:06 12/05/13 Pacific Standard Time
        print(33*("="))
               
#</function4xi>    

# =================================================================================================
#<class4xi class = "DirectoryWalker4Xi" base = "None" child = "None" 
#   synopsis = "a forward iterator that traverses a directory tree"
#   usage = "traversing a directory tree"
#>
# =================================================================================================
class DirectoryWalker4Xi:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker4Xi"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "gets item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            try:
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # pop next directory from stack
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # got a filename
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
    
#</class4xi>        
    
# -------------------------------------------------------------------------------------------------
##<function4xi function = "main" usage = "
#   main function of verify2uri4xi.py
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global path2verify4xi

    global tagindexes4line
    global tagminimums4module
    
    global tagstats4line 
    global tagstats4module 
    global tagstats4system
    
    global tagvalues4attributes

    global TagKB4Xi
    global keys2tags
    global keys2start
    global keys2end

    global extension2file

    global start2style     
    global end2style      
    global start2paragraph
    global end2paragraph  
    global start2anchor   
    global end2anchor      
    global start2table     
    global end2table       
    global start2tablebody 
    global end2tablebody   
    global start2tr        
    global end2tr          
    global start2td       
    global end2td          
    global start2header2   
    global end2header2     
    global start2HEADER2   
    global end2HEADER2     
      
    # ---------------------------------------------------------------------------------------------
    #
    # ---------------------------------------------------------------------------------------------    
    tagstats4system = {} 
    
    count2errors = 0
    count2failures = 0
      
    # ---------------------------------------------------------------------------------------------
    # (STEP 1/33)
    # ---------------------------------------------------------------------------------------------        
    if debug2xi is True:
        print ('(STEP 1B/33) OF MAIN VERIFY2URI4XI - TAGS TO BE VERIFIED (printed with end): ', time4xi())  
        for key in sorted(keys2start):
            print (key, '/>')     
            # <B />
            # <H2 />
            # <a />
            # <b />
            # <h2 />
            # <p />
            # <style />
            # <table />
            # <tbody />
            # <td />
            # <tr />
    
    # ---------------------------------------------------------------------------------------------
    # (STEP 2/33)
    # ---------------------------------------------------------------------------------------------                  
    if debug2xi is True:
        print("(STEP 2/33) OF MAIN VERIFY2URI4XI - VERIFYING ", path2verify4xi)
        # ..//..//..//..//studio4xi//python//3.3//html//
        # ..//..//..//..//sw4xi//python33//html//
        # ..//..//..//..//scope4xi//041721//zap//cc//html//xi//
             
    # ---------------------------------------------------------------------------------------------
    # (STEP 3/33) - WALKING
    # ---------------------------------------------------------------------------------------------     
    if debug2xi is True:
        print ("(STEP 3A/33) OF MAIN VERIFY2URI4XI - STARTED WALKING ", path2verify4xi)
        # ..//..//..//..//studio4xi//python//3.3//html//
    for file2walk in DirectoryWalker4Xi(path2verify4xi):
 
        if os.path.isdir(file2walk):
            pass                
        if os.path.isfile(file2walk):
            text2find = extension2file
            index2dragon = str.find(file2walk, text2find)  
            if index2dragon == -1:
                if debug2xi is True:
                    print ('(STEP 3B/33) OF VERIFY2URI4XI - SKIPPED: ', file2walk)
                    # ..//..//..//..//studio4xi//python//3.3//html//en_mp_sw_xi4.html
                    # ..//..//..//..//studio4xi//python//3.3//html//index.html 
            else:
                if debug2xi is True:
                    print ('(STEP 3C/33) OF VERIFY2URI4XI - APPROVED: ', file2walk)
                    # ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html    
                tagstats4system[file2walk] = {} 
                for key in keys2tags:
                    tagstats4system[file2walk] [key] = 0
                    if debug2xi is True:
                        print ("TAGSTATS4SYSTEM[", file2walk, "] [", key, "]", tagstats4system[file2walk] [key])
                
                verify2uri4xi(file2walk)

    # ---------------------------------------------------------------------------------------------
    # (STEP 4/33) - SYSTEM LEVEL VERIFYING STATISTICS
    # ---------------------------------------------------------------------------------------------               
    if debug2xi is True:
        print ("(STEP 4A/33) OF MAIN VERIFY2URI4XI - SYSTEM LEVEL VERIFYING STATISTICS ", time4xi())
        # 09:48:06 12/05/13 Pacific Standard Time 
    keys2modules = tagstats4system.keys()

    # --------------------------------------------------------------------------------------------------------------
    # FILES
    # --------------------------------------------------------------------------------------------------------------      
    for key2module in sorted(keys2modules):
        text2find = extension2file
        index2dragon = str.find(key2module, text2find)  
        if index2dragon == -1:
            if debug2xi is True:
                print ('(STEP 5A/33) OF MAIN VERIFY2URI4XI - SKIPPED: ', key2module)
                # ..//..//..//..//studio4xi//python//3.3//html//en_mp_sw_xi4.html
                # ..//..//..//..//studio4xi//python//3.3//html//index.html       
        else:        
            # -------------------------------------------------------------------------------------------------------
            # (STEP 5B/33) - FILE LEVEL VERIFYING STATISTICS
            # -------------------------------------------------------------------------------------------------------        
            if debug2xi is True:
                print ("(STEP 5B/33) OF MAIN VERIFY2URI4XI - FILE LEVEL VERIFYING STATISTICS FOR ", key2module, "  ", time4xi())
                # ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html    09:48:06 12/05/13 Pacific Standard Time
                # 
            # -------------------------------------------------------------------------------------------------------
            # KEYS
            # -------------------------------------------------------------------------------------------------------                       
            for key2tag in sorted(keys2tags):
                if key2tag[1] == '/':
                    # --------------------------------------------------------------------------------------------
                    # SKIP VERIFYING END TAG
                    # --------------------------------------------------------------------------------------------   
                    pass
                else:
                    # ---------------------------------------------------------------------------------------------
                    # (STEP 6/33) - TAG VERIFYING 
                    # ---------------------------------------------------------------------------------------------        
                    ack2tag = True  # default is ok for tags
                    if debug2xi is True:
                        print ("(STEP 6A/33) OF MAIN VERIFY2URI4XI - VERIFYING TAG: ", key2tag, ': ', tagstats4system[key2module] [key2tag])  
                        # VERIFYING TAG:  <B :  984
                     
                    # ---------------------------------------------------------------------------------------------
                    # TRY TAG VERIFYING
                    # ---------------------------------------------------------------------------------------------             
                    try:
                        # -----------------------------------------------------------------------------------------
                        # 
                        # -----------------------------------------------------------------------------------------     
                        if tagstats4system[key2module] [key2tag] < tagminimums4module [key2tag]:
                            # -------------------------------------------------------------------------------------
                            # TAG EXISTS LESS THAN REQUIRED 
                            # -------------------------------------------------------------------------------------                           
                            try:
                                # ---------------------------------------------------------------------------------
                                # (STEP 7/33) - CHECK IF SYNONYM TAG CAN HELP 
                                # ---------------------------------------------------------------------------------
                                key2synonym = TagKB4Xi[key2tag] [32]
                                if key2synonym == 'None':
                                    # -----------------------------------------------------------------------------
                                    # MISSING TAG HAS NO SYNONYM  
                                    # -----------------------------------------------------------------------------                            
                                    ack2tag = False
                                    count2errors = count2errors + 1  
                                    print ("(STEP 7Z1/33) OF MAIN VERIFY2URI4XI *** ERROR IN FILE: ", key2module, " MISSING TAG: ", key2tag, " QTY: ", tagstats4system[key2module] [key2tag], " < ", tagminimums4module [key2tag]) 
                                    # ---------------------------------------------------------------------------------
                                    # 
                                    # ---------------------------------------------------------------------------------                                              
                                else:
                                    # -----------------------------------------------------------------------------
                                    # MISSING TAG HAS SYNONYM TAG - CHECK ITS OCCURRENCY 
                                    # -----------------------------------------------------------------------------
                                    if debug2xi is True:
                                        print ("(STEP 7B/33) OF MAIN VERIFY2URI4XI - CHECKING IN FILE SYNONUM TAG: ", key2synonym, " QTY: ", tagstats4system[key2module] [key2synonym], " MINUM: ", tagminimums4module [key2synonym])
                                    
                                    # -----------------------------------------------------------------------------
                                    # 
                                    # -----------------------------------------------------------------------------          
                                    if ((tagstats4system[key2module] [key2synonym] < tagminimums4module [key2synonym]) or (tagstats4system[key2module] [key2synonym] == 0)):
                                        # -------------------------------------------------------------------------
                                        # SYNONYM TAG DID NOT OCCUR IN FILE  
                                        # -------------------------------------------------------------------------
                                        ack2tag = False
                                        count2errors = count2errors + 1 
                                        print ("(STEP 7Z2/33) OF MAIN VERIFY2URI4XI *** ERROR IN FILE: ", key2module, " MISSING TAG: ", key2tag, " QTY: ", tagstats4system[key2module] [key2tag], " < ", tagminimums4module [key2tag])
                                        print ("(STEP 7Z3/33) OF MAIN VERIFY2URI4XI *** ERROR IN FILE: ", key2module, " SYNONYM TAG: ", key2synonym, " QTY: ", tagstats4system[key2module] [key2synonym]) 
                                        # 
                                        # -----------------------------------------------------------------------------
                                        # 
                                        # -----------------------------------------------------------------------------                                             
                                    else:
                                        # -------------------------------------------------------------------------
                                        # SYNONYM TAG EXISTS  
                                        # -------------------------------------------------------------------------
                                        ack2tag = True
                                        if debug2xi is True:
                                            print ("(STEP 7E/33) OF MAIN VERIFY2URI4XI - ACCEPTED TAG: ", key2tag, " SYNONYM: ", key2synonym, " QTY-SYNONYM: ", tagstats4system[key2module] [key2synonym])
                                        
                                        # -----------------------------------------------------------------------------
                                        # EOF SYNONYM CHECK 
                                        # -----------------------------------------------------------------------------                                                    
                                # -------------------------------------------------------------------------------------
                                # 
                                # -------------------------------------------------------------------------------------  
                            except:
                                print ("(STEP 7Z4/33) OF MAIN VERIFY2URI4XI *** ERROR *** FAILED IN SYNONYM HANDLING ***") 
                                count2failures = count2failures + 1                                                                                                             
                        else:
                            # -----------------------------------------------------------------------------------------
                            # TRYING TAG EXISTS AS REQUIRED OR TAG NOT PRESENT AT ALL  
                            # -----------------------------------------------------------------------------------------                      
                            try:
                                # -------------------------------------------------------------------------------------
                                # TAG EXISTS AS REQUIRED OR TAG NOT PRESENT AT ALL   
                                # -------------------------------------------------------------------------------------                                  
                                if tagstats4system[key2module] [key2tag] > 0:
                                    # ---------------------------------------------------------------------------------
                                    # TAG FOUND ON FILE   
                                    # ---------------------------------------------------------------------------------           
                                    try:
                                        # -----------------------------------------------------------------------------
                                        # CHECK END TAG FOR THIS TAG 
                                        # -----------------------------------------------------------------------------                                
                                        try:
                                            key2end = TagKB4Xi[key2tag] [33]  
                                            
                                            try:
                                                if key2end == '/>':
                                                    # ---------------------------------------------------------------------
                                                    # NO SPECIFIC END TAG FOR THIS TAG - NOTHING TO CHECK  
                                                    # ---------------------------------------------------------------------  
                                                    pass
                                                else:
                                                    # -------------------------------------------------------------------------
                                                    # CHECK WHETHER NUMBER OF START TAGS MATCHES TO THAT OF END TAGS  
                                                    # -------------------------------------------------------------------------  
                                                    try:
                                                        if tagstats4system[key2module] [key2tag] == tagstats4system[key2module] [key2end]:
                                                            # ---------------------------------------------------------------------
                                                            # NUMBER OF START TAGS MATCHES TO THAT OF END TAGS  
                                                            # ---------------------------------------------------------------------  
                                                            if debug2xi is True:
                                                                print ("(STEP 8A/33) OF MAIN VERIFY2URI4XI - MATCHING TAG: ", key2tag, " QTY: ", tagstats4system[key2module] [key2tag], " EQ ", tagstats4system[key2module] [key2end], " = QTY OF END_TAG: ", key2end)
                                                                # MATCHING TAG:  <B  QTY:  984  EQ  984  = QTY OF END_TAG:  </B>
                                                                # MATCHING TAG:  <h2  QTY:  7  EQ  7  = QTY OF END_TAG:  </h2>
                                                                # MATCHING TAG:  <style  QTY:  1  EQ  1  = QTY OF END_TAG:  </style>
                                                                # MATCHING TAG:  <table  QTY:  1  EQ  1  = QTY OF END_TAG:  </table>
                                                                # MATCHING TAG:  <tbody  QTY:  1  EQ  1  = QTY OF END_TAG:  </tbody>
                                                                # MATCHING TAG:  <td  QTY:  26  EQ  26  = QTY OF END_TAG:  </td>
                                                                # MATCHING TAG:  <tr  QTY:  10  EQ  10  = QTY OF END_TAG:  </tr>
                                                            
                                                            ack2tag = True                                                                 
                                                        else:
                                                            # ---------------------------------------------------------------------
                                                            # MISMATCH BETWEEN NUMBER OF START AND NUMBER OF END TAGS  
                                                            # ---------------------------------------------------------------------                                      
                                                            ack2tag = False
                                                            count2errors = count2errors + 1
                                                            print ("(STEP Z1/33) OF MAIN VERIFY2URI4XI ** POSSIBLE ERROR IN FILE: ", key2module, " TAG: ", key2tag, " QTY: ", tagstats4system[key2module] [key2tag], " N.E. ", tagstats4system[key2module] [key2end], " = QTY OF END_TAG: ", key2end)
                                                            print (" Note: tags such as <p for paragraph and <param for scripts not being differiented i.e. html file may be ok!")
                                                            #*** ERROR IN FILE:  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html  TAG:  <a  QTY:  4517  N.E.  4514  = QTY OF END_TAG:  </a
                                                            #*** ERROR IN FILE:  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html  TAG:  <b  QTY:  11048  N.E.  6602  = QTY OF END_TAG:  </b>
                                                            #*** ERROR IN FILE:  ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html  TAG:  <p  QTY:  5  N.E.  1  = QTY OF END_TAG:  </p>
                                                                
                                                            # -------------------------------------------------------------------------
                                                            # EOF CHECK WHETHER NUMBER OF START TAGS MATCHES TO THAT OF END TAGS  
                                                            # -------------------------------------------------------------------------
                                                    except:
                                                        # -----------------------------------------------------------------------------
                                                        # EXCEPTION TAG EXISTS & AS REQUIRED  
                                                        # -----------------------------------------------------------------------------                                        
                                                        print ("(STEP 9A/33) OF MAIN VERIFY2URI4XI *** ERROR *** FAILED ***") 
                                                        count2failures = count2failures + 1
                                                        try:
                                                            if debug2xi is True:
                                                                print ("(STEP 9B/33) OF MAIN VERIFY2URI4XI KEY2FILE: ", key2module, " KEY2TAG: ", key2tag, " KEY2END: ", key2end)
                                                            # 
                                                        except:
                                                            pass
                                                                                                                                   
                                                # -----------------------------------------------------------------------------
                                                # EOF TAG EXISTS & AS REQUIRED  
                                                # -----------------------------------------------------------------------------
                                            except:
                                                # -----------------------------------------------------------------------------
                                                # EXCEPTION TAG EXISTS & AS REQUIRED  
                                                # -----------------------------------------------------------------------------                                        
                                                print ("(STEP 10A/33) OF MAIN VERIFY2URI4XI *** ERROR *** FAILED ***") 
                                                count2failures = count2failures + 1 
                                                try:
                                                    if debug2xi is True:
                                                        print ("(STEP 10B/33) OF MAIN VERIFY2URI4XI KEY2FILE: ", key2module, " KEY2TAG: ", key2tag, " KEY2END: ", key2end) 
                                                except:
                                                    pass                                                                                          
                                        except:
                                            # -----------------------------------------------------------------------------
                                            # EXCEPTION TAG EXISTS & AS REQUIRED  
                                            # -----------------------------------------------------------------------------                                        
                                            print ("(STEP 11A/33) OF MAIN VERIFY2URI4XI *** ERROR *** FAILED ***") 
                                            count2failures = count2failures + 1 
                                            try:
                                                if debug2xi is True:
                                                    print ("(STEP 11B/33) OF MAIN VERIFY2URI4XI KEY2FILE: ", key2module, " KEY2TAG: ", key2tag, " KEY2END: ", key2end) 
                                            except:
                                                pass                                                                                    
                                    except:
                                        # -----------------------------------------------------------------------------
                                        # EXCEPTION TAG EXISTS & AS REQUIRED  
                                        # -----------------------------------------------------------------------------                                        
                                        print ("(STEP 12A/33) OF MAIN VERIFY2URI4XI *** ERROR *** FAILED ***") 
                                        count2failures = count2failures + 1 
                                        try:
                                            if debug2xi is True:
                                                print ("(STEP 12B/33) OF MAIN VERIFY2URI4XI KEY2FILE: ", key2module, " KEY2TAG: ", key2tag, " KEY2END: ", key2end) 
                                        except:
                                            pass                                          
                                    # ---------------------------------------------------------------------------------
                                    # EOF TAG PRESENT   
                                    # ---------------------------------------------------------------------------------                                                                                                        
                                else:        
                                    # ---------------------------------------------------------------------------------
                                    # TAG NOT PRESENT AT ALL  
                                    # ---------------------------------------------------------------------------------                                               
                                    pass
                                # -------------------------------------------------------------------------------------
                                # EOF TAG EXISTS AS REQUIRED OR TAG NOT PRESENT AT ALL   
                                # -------------------------------------------------------------------------------------                                          
                            except:
                                # -------------------------------------------------------------------------------------
                                # EXCEPTION TAG EXISTS AS REQUIRED OR TAG NOT PRESENT AT ALL   
                                # -------------------------------------------------------------------------------------                                   
                                print ("(STEP 13/33) OF MAIN VERIFY2URI4XI *** ERROR *** FAILED ***") 
                                count2failures = count2failures + 1         
                                
                            # ---------------------------------------------------------------------------------
                            # EOF TRYING TAG EXISTS AS REQUIRED OR TAG NOT PRESENT AT ALL 
                            # ---------------------------------------------------------------------------------                                       
                            if key2tag[1] == '/':
                                pass
                            else:
                                if ack2tag is True:
                                    if debug2xi is True:    
                                        print ("(STEP 14A/33) OF MAIN VERIFY2URI4XI - IN FILE: ", key2module, " ACCEPTED TAG: ", key2tag, " QTY: ", tagstats4system[key2module] [key2tag])
                                        # ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html  ACCEPTED TAG:  <B  QTY:  984
                                        #  
                                else:
                                    # JATKA
                                    print("(STEP 14Z2/33) OF MAIN VERIFY2URI4XI ** POSSIBLE ERROR - TAG EXISTS AS REQUIRED OR TAG NOT PRESENT AT ALL, ACK2TAG: ", ack2tag) 
                                    print (" Note: tags such as <p for paragraph and <param for scripts not being differiented i.e. html file may be ok!")
                                    print("(STEP 14Z2/33) OF MAIN VERIFY2URI4XI - MODULE STATISTICS: ", tagstats4system[key2module] [key2tag], " - FOR MODULE: ", key2module, " FOR TAG: ", key2tag) 
                                    print("(STEP 14Z3/33) OF MAIN VERIFY2URI4XI - DEFINED TAGMINIMUMS4MODULE[", key, ']', tagminimums4module[key])
                                    print("(STEP 14Z4/33) OF MAIN VERIFY2URI4XI - LAST LINE STATISTICS ", 'TAGSTATS4LINE[', key, ']: ', tagstats4module[key]) 
                                    # (STEP 14Z2/33) OF MAIN VERIFY2URI4XI *** ERROR - TAG EXISTS AS REQUIRED OR TAG NOT PRESENT AT ALL, ACK2TAG:  False
                                    # - MODULE STATISTICS:  2  - FOR MODULE:  E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//halongbay//spec//brand//yourdragonxi.html  FOR TAG:  <p
                                    # - DEFINED TAGMINIMUMS4MODULE[ <a ] 0
                                    # - LAST LINE STATISTICS  TAGSTATS4LINE[ <a ]:  38
                                    
                                                    
                            # ----------------------------------------------------------------------------------
                            # EOF TAG VERIFYING
                            # ----------------------------------------------------------------------------------
                                                                       
                    except:
                        # ------------------------------------------------------------------------------------------
                        # FAILED TAG VERIFYING
                        # ------------------------------------------------------------------------------------------                        
                        print ("(STEP 15/33) OF MAIN VERIFY2URI4XI *** ERROR *** FAILED IN TAG LEVEL VERIFYING STATISTICS ", time4xi()) 
                        count2failures = count2failures + 1         
    
            # ----------------------------------------------------------------------------------------------------------
            # EOF KEYS  
            # ---------------------------------------------------------------------------------------------------------- 
                                             
    # --------------------------------------------------------------------------------------------------------------
    # EOF FILES
    # --------------------------------------------------------------------------------------------------------------      

    # --------------------------------------------------------------------------------------------------------------
    # (STEP 17/33) LINES
    # --------------------------------------------------------------------------------------------------------------       
    if debug2xi is True:
        print ("(STEP 17A/33) OF MAIN VERIFY2URI4XI - LINE LEVEL CHECK ", time4xi())  
    
    try:
        keys2file = tagstats4line.keys()
    except:
        print ("(STEP 17Z1/33) OF MAIN VERIFY2URI4XI *** FAILED IN LINE LEVEL CHECK ", time4xi())
                
    for key2file in keys2file:
        try:
            kb2lines = tagstats4line[key2file]
        except:
            print ("(STEP 17Z2/33) OF MAIN VERIFY2URI4XI *** FAILED IN LINE LEVEL CHECK ", time4xi())
        try:        
            keys2lines =  kb2lines.keys()
        except:
            print ("(STEP 17Z3/33) OF MAIN VERIFY2URI4XI *** FAILED IN LINE LEVEL CHECK ", time4xi())    
        for key2line in sorted(keys2lines):
            if debug2xi is True:
                print ('='*33)    
            try:    
                kb2tags = tagstats4line[key2file] [key2line]
            except:
                print ("(STEP 17Z4/33) OF MAIN VERIFY2URI4XI *** FAILED IN LINE LEVEL CHECK ", time4xi())    
            try:    
                keys2tags = kb2tags.keys()
            except:
                print ("(STEP 17Z5/33) OF MAIN VERIFY2URI4XI *** FAILED IN LINE LEVEL CHECK ", time4xi())
            
            count2start4anchor = 0
            count2end4anchor = 0                
            for key2tags in sorted(keys2tags):
 
                try:
                    if (tagstats4line [key2file]  [key2line]  [key2tags]) > 0:
                        if debug2xi is True:    
                            print('TAGSTATS4LINE [', key2file, '] [ ', key2line, '] [ ', key2tags, '] ', tagstats4line [key2file]  [key2line]  [key2tags])
                        
                            # TAGSTATS4LINE [ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [  1 ] [  <style ]  1
                            # TAGSTATS4LINE [ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [  3 ] [  </style> ]  1
                            #                         
                            # TAGSTATS4LINE [ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [  4 ] [  <p ]  1  <-- end not in this line
                            # 
                            # TAGSTATS4LINE [ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [  5 ] [  </a> ]  1 <-- end in the same line
                            # TAGSTATS4LINE [ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [  5 ] [  <a ]  1
                            # 
                            # TAGSTATS4LINE [ ..//..//..//..//studio4xi//python//3.3//html//index2studio4xi.html ] [  7 ] [  <table ]  1  <-- end not in this line
                            # 
                        if key2tags == start2anchor:
                            count2start4anchor = tagstats4line [key2file]  [key2line]  [key2tags]
                        if key2tags == end2anchor:
                            count2end4anchor = tagstats4line [key2file]  [key2line]  [key2tags]
                    else:
                        pass
                except:
                    print ("(STEP 17Z6/33) OF MAIN VERIFY2URI4XI *** FAILED IN LINE PRINT ", time4xi())
            try:            
                if ((count2start4anchor > 0) or (count2end4anchor > 0)):
                    if count2start4anchor > count2end4anchor:
                        print("(STEP 17Z7/33) OF MAIN VERIFY2URI4XI *** ERROR: TOO MANY START ANCHORS - COUNT2START4ANCHOR: ", count2start4anchor, " > ", count2end4anchor, " (COUNT2END4ANCHOR) ", tagstats4line [key2file]  [key2line]  [key2tags])
                        print("(STEP 17Z8/33) OF MAIN VERIFY2URI4XI ***", 'TAGSTATS4LINE [', key2file, '] [ ', key2line, '] [ ', key2tags, '] ', tagstats4line [key2file]  [key2line]  [key2tags])
                        print("(STEP 17Z9/33) OF MAIN VERIFY2URI4XI ** Note: line number might be the one with faulty tag whereas for faulty tag yoy may have to see ERROR WITH TAG **") 
                        # 
                        # <br />~ <a>FDevice 1 can be recharged by taking charged cartridges from Resource Device RD
                    if count2start4anchor < count2end4anchor:
                        print ("(STEP 17Z10/33) OF MAIN VERIFY2URI4XI *** ERROR: TOO MANY END ANCHORS - COUNT2START4ANCHOR: ", count2start4anchor, " < ", count2end4anchor, " (COUNT2END4ANCHOR) ", tagstats4line [key2file]  [key2line]  [key2tags])
                        print ("(STEP 17Z11/33) OF MAIN VERIFY2URI4XI ***", 'TAGSTATS4LINE [', key2file, '] [ ', key2line, '] [ ', key2tags, '] ', tagstats4line [key2file]  [key2line]  [key2tags])
                        print ("(STEP 17Z12/33) OF MAIN VERIFY2URI4XI ** Note: line number might be the one with faulty tag whereas for faulty tag yoy may have to see ERROR WITH TAG **")
                        # [ E://temp//work//py//spec_des_003.html ] [  176 ] [  <tr ]  0
                        # <br />~ FDevice 1 can be recharged by taking charged cartridges from Resource Device RD</a>
            except:
                print ("(STEP 17Z7/33) OF MAIN VERIFY2URI4XI *** FAILED IN LINE LEVEL CHECK ", time4xi())        
 
                                                
    # --------------------------------------------------------------------------------------------------------------
    # (STEP 33/33)
    # --------------------------------------------------------------------------------------------------------------              
     
    print('=' *140)
    # ----------------------------------------------------------------------------------------------------------
    # 
    # ----------------------------------------------------------------------------------------------------------                 
    try:
        if debug2xi is True:
            print("(STEP 33A/33) OF MAIN VERIFY2URI4XI VERIFIED TOTALLY ", len(TagKB4Xi), " TAGS IN : ", len(tagstats4system), " FILES ", time4xi())
            # VERIFIED TOTALLY  11  TAGS IN :  1  FILES  09:48:06 12/05/13 Pacific Standard Time
    except:
        pass
        
    if count2errors == 0:
        print("(STEP 33B/33) OF MAIN VERIFY2URI4XI + OK VERIFYING  ", path2verify4xi, " ", time4xi())
        #     
    else:
        print("(STEP 33B/33) OF MAIN VERIFY2URI4XI  ** ", count2errors, " ERRORS IN VERIFYING ", path2verify4xi, " ", time4xi())
        # ***  3  ERRORS IN VERIFYING  ..//..//..//..//studio4xi//python//3.3//html//   09:48:06 12/05/13 Pacific Standard Time
    # ----------------------------------------------------------------------------------------------------------
    # 
    # ----------------------------------------------------------------------------------------------------------                 
    if count2failures == 0:
        print("(STEP 33C/33) OF MAIN VERIFY2URI4XI - PROCESSED FOLDER  ", path2verify4xi, " ", time4xi())
        # PROCESSED FOLDER   ..//..//..//..//studio4xi//python//3.3//html//   09:48:06 12/05/13 Pacific Standard Time
    else:
        print("(STEP 33C/33) OF MAIN VERIFY2URI4XI  *** ", count2failures, " FAILURES PROCESSING FOLDER  ", path2verify4xi, " ", time4xi())
        #  
    print('=' *140)

#</function4xi>    
    
        
# -------------------------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   verify2uri4xi.txt
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of verify2uri4xi.py                            
# ------------------------------------------------------------------------------------------------- 
#"
#/>
